/*
* This file is the main code of Texdi
* Copyright (C) <2016>  <alkeon> [alkeon@autistici.org][PGP sign]
   
* Texdi is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* Texdi is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with Texdi.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <iostream>
#include <string>
#include <fstream>
#include "tedi2txt.h"
using namespace std;


void traduccion(std::string archivo,std::string archivo_final,std::string encabezado,std::string pie){
	std::ifstream inicio(archivo.c_str());
	std::string line;
	std::string texto;
	std::ofstream texto2(archivo_final.c_str());
	int control=0;
	while(getline(inicio,line)){
		size_t excla=line.find('!');
		size_t comi=line.find("\"");
		if(excla==std::string::npos){
			size_t almoh=line.find('#');
			if(almoh==std::string::npos){
				size_t ul=line.find("__");
				if(ul==std::string::npos){
					size_t el=line.find(",,");
					if(el==std::string::npos){
						size_t li=line.find("--");
						if(li==std::string::npos){
							if(comi==std::string::npos){
								size_t lla1=line.find("{");
								if(lla1!=std::string::npos){
									//std::cout << line << std::endl;
									line=contenedores(line);
								}
								size_t corchete=line.find("[");
								if(corchete!= std::string::npos){
									line=enlaces(line);

								}
								size_t par1=line.find("(");
								if(par1!=std::string::npos ){
									size_t lla2=line.find("{");
									if(lla2==std::string::npos){
										line=imagenes(line);
									}
								}
								size_t hor=line.find("|");
					
								if(hor!=std::string::npos){
									
									texto+="\n";
									
								}
								size_t menor=line.rfind(" ");
								size_t mayor=line.find("<");
								if(menor==line.size()-1 && menor !=std::string::npos && mayor==std::string::npos){
									
									texto+=line+ "\n";
								}else{
									line.erase(0,1);
									texto+=line+ "\n";
								}
							}else{
								++comi;
								line=line.substr(comi,line.size()-3);
								cout << "Comillas fuera " << line << endl;
								texto+=line+"<p>\n";
								
							}
						}else{
							std::string parte1;
							li+=2;
							parte1=line.substr(li,line.length()-1);
							texto+="--"+parte1+"\n";
						}
					}else{
						texto+="\n";
					}
				}else{
					size_t control=line.find('<');
					if(control==std::string::npos){
						texto+="\n";
					}else{
						line=line.erase(control,1);
						texto+=line+"\n";
					}
					
				}
			}else{
				line=titulo(line);
				texto+=line+"\n";
			}
		}else{
			if(comi==std::string::npos){
				size_t fin=line.find("!end");
				if(fin==std::string::npos){
					line=line.substr(5);
					line+=encabezado;
					texto+=line + "\n";
				}else{
					line=pie;
					texto+=line;
				}
			}else{
				texto+=line+"\n";
			}
		}
	}
	texto2 << texto;
	inicio.close();
	
}
string enlaces(std::string linea){
	size_t corchete=linea.find("[");
	size_t paren=linea.find("(");
	if(paren!= std::string::npos){
		paren+=1;
		size_t paren2=linea.find(")");
		size_t cor2=linea.find("]");
		std::string enlace;
		paren2=paren2-paren;
		enlace=linea.substr(paren,paren2);
		paren2=linea.find(")");
		std::string parte1;
		if(corchete!=0)
			parte1=linea.substr(0,corchete);
		std::string parte2;
		size_t fin=linea.length();
		fin-=1;
		if(cor2!=fin){
			cor2=cor2-(paren2+1);
			parte2=linea.substr(paren2+1,cor2);
			std::string parte3;
			cor2=linea.find("]");
			parte3=linea.substr(cor2+1);
			linea=parte1+parte2+"{"+enlace+"}"+parte3;
			return linea;
		}else{
			cor2=cor2-(paren2+1);
			parte2=linea.substr(paren2+1,cor2);
			if(corchete!=0){
				linea=parte1+parte2+"{"+enlace+"}";
				return linea;
			}else{
				linea=parte2+"{"+enlace+"}";
				return linea;
			}
		}
	}
}
string imagenes(std::string linea){
	size_t corchete=linea.find("[");
	size_t par1=linea.find("(");
	size_t llat1=linea.find("{");
	size_t par2=linea.find(")");
	if(par2!= std::string::npos && llat1==std::string::npos){
		par1+=1;
		par2=par2-par1;
		std::string enlace;
		enlace=linea.substr(par1,par2);
		par1=linea.find("(");
		par2=linea.find(")");
		std::string parte1;
		if(par1!=0)
			parte1=linea.substr(0,par1);
		std::string parte2;
		std::string atributo;
		parte2=linea.substr(par2+1);
		par1=linea.find("(");
		par2=linea.find(")");
		if(par1!=0 && par2!=linea.length()-1){				
			linea=parte1+parte2;
			return linea;
		}else {
			
			if(par2==linea.length()-1){
				linea=parte1;
				return linea;
			}else{
				linea=parte2;
				return linea;
			}
		}
	}
}
string titulo(std::string linea){
	size_t exa1=linea.find("#");
	size_t aux=exa1;
	int ti=0;
	std::string ti2;
	while(exa1!=std::string::npos && linea[exa1]=='#'){
		
		++exa1;
		std::cout << linea.size()-2 << std::endl;
		
		linea=linea.substr(exa1,linea.size()-1);
		std::cout << linea.size() << std::endl;
		std::cout << linea << std::endl;
		
		exa1=linea.find("#");

		++ti;
		ti2+="*";
	}
	
		
		linea=ti2+linea;
		return linea;
}
string contenedores(std::string linea){
	size_t par_nuevo=linea.find("(");
	size_t par2=linea.find(")");
	size_t lla1=linea.find("{");
	if(par2!= std::string::npos){
		par_nuevo+=1;
		par2=par2-par_nuevo;
		std::string enlace;
		enlace=linea.substr(par_nuevo,par2);
		par_nuevo=linea.find("(");
		par2=linea.find(")");
		lla1=linea.find("{");
		size_t lla2=linea.find("}");
		std::string parte1;
		if(lla1!=0)
			parte1=linea.substr(0,lla1);
		std::string parte2;
		par2+=1;
		lla2=lla2-par2;
		parte2=linea.substr(par2,lla2);
		if(lla1!=0){
			linea=parte1+parte2;
			return linea;
		}else {
			linea=parte2;
			return linea;
		}
	}
}
