#include <string>
#include <iostream>
#include <fstream>
#include "tedi2html.h"
using namespace std;
bool test_file(string archivo){
	ifstream inicio(archivo.c_str());
	string line;
	bool fail=false;
	bool header=false;
	bool end=false;
	int quotation=0;
	int paren_end=0;
	int square_end=0;
	int keys_end=0;
	int paren_start=0;
	int square_start=0;
	int keys_start=0;
	int start_list=0;
	int end_list=0;
	while(getline(inicio,line)){
		if(line[0]!='<'){
			size_t inicio=line.find("!head");
			size_t fin=line.find("!end");
			if(inicio!=std::string::npos or fin!=std::string::npos){
				if(inicio!=std::string::npos){
					header=true;
				}
				if(fin!=std::string::npos){
					end=true;
				}
			}else{
				size_t ul=line.find("__");
				if(ul!=std::string::npos)
					++start_list;
				size_t ulf=line.find(",,");
				if(ulf!=std::string::npos)
					++end_list;

				if(line[0]=='"'){
					line=line.substr(1,line.size()-1);
					++quotation;
					cout << line << endl;
					size_t comi2=line.find("\"");
					if(comi2!=std::string::npos)
						++quotation;
				}else{
					int etiq=main_tag(line);
					if(etiq!=-1){
						for(int i=0;i<line.length();++i){
							if(line[i]=='{')
								++keys_start;
							if(line[i]=='(')
								++paren_start;
							if(line[i]=='[')
								++square_start;
							if(line[i]=='}')
								++keys_end;
							if(line[i]==')')
								++paren_end;
							if(line[i]==']')
								++square_end;
						}
					}
				}
			}
		}
	}

	bool result=false;
	if(header && end){
		result=true;
		if(quotation%2!=0){	
			cout << "The number of quotation marks doesn't match." << endl;
			result=false;
		}
		if(paren_start!=paren_end){
			cout << "The number of  doesn't match." << endl;
			result=false;
		}
		if(square_start!=square_end){
			cout << "The number of square brackets doesn't match." << endl;
			result=false;
		}
		if(keys_start!=keys_end){
			cout << "The number of keys doesn't match." << endl;
			result=false;
		}
		if(start_list!=end_list){
			cout << "The number of lists doesn't match." << endl;
			result=false;
		}
	}else{
		if(!header)
			cout << "Insert \"!head\" at the start of the file."<< endl;
		if(!end)
			cout << "Insert \"!end\" at the end of the file." <<endl;
	}
	return result;
}
